; Align data or code to a power of 2. This macro, in contrast to MASM's, allows alignment grater than 16: 32,64,128... 
; This macro woks for EXE's and DLL's that consist of one module without problems. However, if the current module is not
; the main-module or an library, then you should notice, that the linker glues the section from different modules with 
; an alignment of 16 for code and 256 for data (?) - so grater alignments are not possible in this modules (except, you 
; write in each module an '_align X'  at the last line of corresponding segment, whereas X the greatest used alignment is).
; - by qWord -
_align macro nAlign:req,dbFill

	IFDEF algin_zero_lbl_code
		goto skip
	ELSE
		_TEXT SEGMENT
			align_mark_code:
			org 0
			algin_zero_lbl_code:
			org align_mark_code
		_TEXT ENDS
		_DATA SEGMENT
			align_mark_data:
			org 0
			algin_zero_lbl_data:
			org align_mark_data
		_DATA ENDS
		_BSS SEGMENT
			align_mark_bss:
			org 0
			algin_zero_lbl_bss:
			org align_mark_bss
		_BSS ENDS
	ENDIF
:skip
	;; check if power of two
	align_msk  = 2
	align_flag = 0
	REPEAT 31
		IF align_msk EQ nAlign
			align_flag = 1
			EXITM
		ENDIF
		align_msk = align_msk SHL 1
	ENDM
	IF align_flag EQ 0
		.err <ALIGN only to power of 2: 2,4,8,16,32,64...>
		EXITM
	ENDIF
	
	;; generate the bit mask
	align_msk = nAlign-1

	IFNB <dbFill>
		align_fill = dbFill
		IFIDNI @CurSeg,<_BSS>
			%echo warning :instructions and initialized data not supported in BSS segments
		ENDIF
	ELSE
		IFIDNI @CurSeg,<_TEXT>
			align_fill = 090h	; for .code  = nop
		ELSEIFIDNI @CurSeg,<_DATA>
			align_fill = 0		; for .data  = 0
		ENDIF
	ENDIF

	IFIDNI @CurSeg,<_TEXT>
		IF nAlign LE 16
			IFB <dbFill>
				IF (nAlign-(align_msk AND ($-OFFSET algin_zero_lbl_code))) EQ 5	; correct masm's align bug
					nop
					db 08Dh,74h,26h,0 ; lea esi,[esi+imm8(0)]
				ELSE
					align nAlign
				ENDIF
			ELSE
				db (nAlign-(align_msk AND ($-OFFSET algin_zero_lbl_code)))*(1 AND ((align_msk AND ($-OFFSET algin_zero_lbl_code)) NE 0)) dup (align_fill)
			ENDIF
		ELSE	;; align > 16
			db (nAlign-(align_msk AND ($-OFFSET algin_zero_lbl_code)))*(1 AND ((align_msk AND ($-OFFSET algin_zero_lbl_code)) NE 0)) dup (align_fill)
		ENDIF
	ELSEIFIDNI @CurSeg,<_DATA>
		db (nAlign-(align_msk AND ($-OFFSET algin_zero_lbl_data)))*(1 AND ((align_msk AND ($-OFFSET algin_zero_lbl_data)) NE 0)) dup (align_fill)
	ELSEIFIDNI @CurSeg,<_BSS>
		db (nAlign-(align_msk AND ($-OFFSET algin_zero_lbl_bss)))*(1 AND ((align_msk AND ($-OFFSET algin_zero_lbl_bss)) NE 0)) dup (?)
	ELSE
		.err <current segemnt not supported by _align-macro>
	ENDIF
endm